class Node:

    def __init__(self, data):
        self.data = data
        self.next = None

    def getData(self):
        return self.data
    
    def getNext(self):
        return self.next

    def setData(self, data):
        self.data = data
    
    def setNext(self, nextNode):
        self.next = nextNode

class Linkedlist:

    def __init__(self):
        '''Listenkopf zeigt auf None (leere Liste)'''
        self.head = None

    def __str__(self):
        txt = 'head'
        node = self.head
        while node != None:
            txt += '-> {0} '.format(node.getData())
            node = node.getNext()
        txt += '-> end'
        return txt

    def isEmpty(self):
        return self.head == None

    def add(self, data):
        temp = Node(data)
        temp.setNext(self.head)
        self.head = temp

    def size(self):
        count = 0
        node = self.head
        while node != None:
            count += 1
            node = node.getNext()
        return count

    def search(self, item):
        node = self.head
        while node != None:
            if node.getData() == item:
                return True
            node = node.getNext()
        return False

    def remove(self, item):
        prevNode = None 
        currNode = self.head
        while currNode != None:
            if currNode.getData() == item:
                if prevNode == None:
                    head = currNode.getNext()
                else:
                    prevNode.setNext(currNode.getNext())

            prevNode = currNode
            currNode = currNode.getNext()
        return False
